#ifndef lint
static char SccsId[] = "%W%  %G%  modified by zxk";
#endif	/* lint */

/* By Xiaokun Zhu, 1993, University of Glasgow */
/* The following code is being made available under a 
 * GNU COPYING "copyleft" license, and is owned by
 * Xiaokun Zhu 
 */

/* #define CHKCACH */


#include <stdio.h>
#include <memory.h>
#include <ctype.h>
#include <string.h>
#include <pwd.h>
#include <sys/param.h>

#include "ptyx.h"		/* X headers included here. */
#include <X11/Xos.h>

#include "HZinput.h"

#define  IS_HZ(c)	(c & 0x80)
#define LENGTH 32           /* things for LX dictionary */
#define TOTAL 2048
#define GBHASH(P) \
   ( (((*(BYTE *)(P) - 0xb0)*94) + ((*(BYTE *)((P)+1)) - 0xa1)) &0x7ff)
#define CONV_WORD( P )   ( ((*(BYTE *)(P))<<8) + (*(BYTE *)((P)+1)) ) 
#define BIG5HASH(P) \
  ( (((unsigned)(*(P)) - 0xa4) * 157 + \
    (((unsigned)*((P)+1) < 0x80) ? (unsigned)*((P)+1) - 0x40 :\
                                  (unsigned)*((P)+1) - 0x62)) &0x7ff  )

typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef struct _HZINFORMATION {  /* for display HZ choice information */
     unsigned char relIdx;
     unsigned char numItem;
    } HZINF;
                    /* for Wild Code process */
typedef struct _WildCode { char wk_key[MAX_INBUF];
                           int wk_infCount;
                          }  WILDKEY; 

static BYTE lxDic[TOTAL][LENGTH];    /* for LX dictionary */
static BYTE (*gblx)[LENGTH] = NULL;
static BYTE (*big5lx)[LENGTH] = NULL;

static char fcbuf[128], fCodebuf[MAX_INBUF];   /* for full code display */
static int fcbufLen=0, fCodeLen, oldLen=0;

static int maxMatchKey=0, numMatchKey, wildKeyOK=0;  /* wildkey */
static int cMatchKey=0, wKeyPos=0, save_cMatchKey;
WILDKEY *wildKeyP=NULL;

static int lxState=0, numLX, lxContinue=0, oldHZitem=0; /* for LX */

int
showlxDic(screen, hztbl, dbuf, dbufLenP, cbuf, cbufLenP, HZbuf, hzLen)
    TScreen *screen;
    HZinputTable *hztbl;
    char *dbuf, *cbuf;
    int *dbufLenP, *cbufLenP, hzLen;
    BYTE *HZbuf;
{
    register int idx;
                             /* show current HZ's LX words */
    while( hzLen > 2 ) 
    {    HZbuf += 2; 
         hzLen -= 2; 
     }
    if( hztbl->encode == GB_ENCODE )
    {  if( *HZbuf < 0xb0 )
           return;
       lxContinue = 1;
       oldHZitem = idx = GBHASH( HZbuf );
       fillLXitem(hztbl, cbuf, cbufLenP, idx, gblx);
       lxState = ( numLX ) ? 1 : 0;
       if( lxState )
       {  strcpy(dbuf,"\266\257\314\254\301\252\317\353");
          *dbufLenP = 8;
          HZi_ReshowUserInput (screen);
         }
      }
    else 
    {  WORD val;
       if( *HZbuf < 0xa4 )
         return;
/*       val = CONV_WORD( HZbuf ); */
       lxContinue = 1;
       oldHZitem = idx = BIG5HASH( HZbuf );
       fillLXitem(hztbl, cbuf, cbufLenP, idx, big5lx);
       lxState = ( numLX ) ? 1 : 0;
       if( lxState )
       {  strcpy(dbuf,"\260\312\272\101\301\160\267\121");
          *dbufLenP = 8;
          HZi_ReshowUserInput (screen);
         }
      }
    HZi_ShowInputChoices (screen);
}

static int
fillLXitem(hztbl, dbuf, dbufLenP, idx, lxdic)
    HZinputTable *hztbl;
    char *dbuf;
    int *dbufLenP, idx;
    BYTE (*lxdic)[LENGTH];
{                           /* fill all words associated with a HZ */
    register int i, max_num=hztbl->maxchoice<<1;
    *dbufLenP = 0;
    dbuf[ (*dbufLenP)++ ] = ' ';
    for (i = 0; i < max_num; i+=2) 
    {  if( lxdic[idx][i] == 0 ) 
           break;
       dbuf[ (*dbufLenP)++ ] = ' ';
       dbuf[ (*dbufLenP)++ ] = hztbl->choicelb[i>>1];
       dbuf[ (*dbufLenP)++ ] = lxdic[idx][i];
       dbuf[ (*dbufLenP)++ ] = lxdic[idx][i+1];
      }
    numLX = i>>1;
    dbuf[ (*dbufLenP)++ ] = ' ';
    dbuf[ (*dbufLenP)++ ] = ' ';
    dbuf[ *dbufLenP ] = '\0';
    return(1);
}

int
getLXState()
{
    return(lxState);
}
int
resetLX()
{
    lxState = 0;
}

int 
lxselect(ch, hztbl, cbuf, HZbuf)
    char ch, *cbuf;
    BYTE *HZbuf;
    HZinputTable *hztbl;
{
    char *dp;
    register int len=0;
    ch = hztbl->choicelb[(hztbl->keytype[ch] & HZ_KEY_SELECTION_NUM)];
    if( (dp = strchr(cbuf, ch)) == NULL )
    {  Bell();  return 0;	} 
    dp += 1;
    while ( *dp != ' ' )
    {   *HZbuf++ = *dp++;  
        len++; 
      }	
    return(len);
}

int 
updateGBLXDic(hztbl, HZbuf)
HZinputTable *hztbl;
BYTE *HZbuf;
{
    if( oldHZitem )
    {  BYTE (*lxPtr)[LENGTH] = lxDic;
       if( hztbl->encode == GB_ENCODE && *HZbuf < 0xb0 )
           return;
       else if( hztbl->encode == BIG5_ENCODE && *HZbuf < 0xa4 )
         return;

       updateLXDic(HZbuf, oldHZitem, lxPtr);
      } 
}

static int 
updateLXDic(HZbuf, idx, lxdic)
BYTE *HZbuf;
int idx;
BYTE (*lxdic)[LENGTH];
{                  /* modify the sequence of LX dictionary entry */
   register int i, j, len;
   for( i=0; i<LENGTH; i+=2 )
       if( (lxdic[idx][i] == *HZbuf) && (lxdic[idx][i+1] == *(HZbuf+1)) )
          break;
       else if( lxdic[idx][i] == '\0' )
          break;
   if( i < LENGTH || lxdic[idx][i] == '\0' )
      len = i + 2;
   else
      len = LENGTH;
   j = (len>>2)<<1;
   for( i=len-3; i>=j; i-- )
          lxdic[idx][i+2] = lxdic[idx][i];
   lxdic[idx][j] = *HZbuf;
   lxdic[idx][j+1] = *(HZbuf+1);
}

int wildKeyInput(ch, hztbl, cTrieNode, ibuf, ibufLenP)
   unsigned char ch;
   HZinputTable *hztbl;
   trieNode *cTrieNode;
   char *ibuf;
   int *ibufLenP;	
{              /* create the current "hzinbuf" */
   register int i, numNextKeys=cTrieNode->tn_numNextKeys;
   register trieNode *tnptr;

   if( hztbl->keytype[ch] == HZ_KEY_WILDKEY && wildKeyOK == 1 )
   {  tnptr = &(hztbl->trieList[cTrieNode->tn_nextKeys]);
      wKeyPos = *ibufLenP;
      for( i=0; i<numNextKeys; i++, tnptr++ )
      {    memcpy(wildKeyP[i].wk_key, ibuf, *ibufLenP);
           wildKeyP[i].wk_key[*ibufLenP] = tnptr->tn_key;
         } 
      numMatchKey = numNextKeys;
      wildKeyOK++;
      (*ibufLenP)++;
     }
   else if( hztbl->keytype[ch] != HZ_KEY_WILDKEY && wildKeyOK > 1 )
   {  for( i=0; i<numMatchKey; i++ )
          wildKeyP[i].wk_key[*ibufLenP] = ch;
      (*ibufLenP)++;
     }
   else  return(-1);

   cMatchKey=0;
   memcpy( ibuf, wildKeyP[cMatchKey].wk_key, *ibufLenP);
   return( 1 );
}

int wildKeyNext(hztbl, ibuf, ibufLenP)
   HZinputTable *hztbl;
   char *ibuf;
   int *ibufLenP;
{
   if( ++cMatchKey == numMatchKey )
   {   cMatchKey--;
       return(-1);
      }
   memcpy( ibuf, wildKeyP[cMatchKey].wk_key, *ibufLenP);
   return( 1 );
}

int wildKeyPrev(hztbl, ibuf, ibufLenP)
   HZinputTable *hztbl;
   char *ibuf;
   int *ibufLenP;
{
   if( --cMatchKey < 0 )
   {   cMatchKey++;  
       return(-1);
      }
   memcpy( ibuf, wildKeyP[cMatchKey].wk_key, *ibufLenP);
   return( 1 );
}

int wildKeyProcess(screen, hztbl, dbuf, dbufLenP, ibuf, ibufLen, 
                   ibufTrieP, cTriePtrP)
    TScreen *screen;
    HZinputTable *hztbl;
    char *dbuf, *ibuf;
    int *dbufLenP, ibufLen;
    trieNode *ibufTrieP[], **cTriePtrP;
{             /* match a new input keys sequence */
    int i, save_dLen=*dbufLenP;
    trieNode *save_itP, *save_ctP;
    register trieNode *ctrieP=hztbl->trieList;
    save_itP = ibufTrieP[wKeyPos];
    save_ctP = *cTriePtrP;
    *dbufLenP = 0;
    for (i = 0; i < ibufLen; i++) {
	unsigned char ch = ibuf[i];
	register int j, numNextKeys;

	ibufTrieP[i] = ctrieP;
	numNextKeys = ctrieP->tn_numNextKeys;
	ctrieP = &(hztbl->trieList[ctrieP->tn_nextKeys]);
	for (j = 0; j < numNextKeys; j++, ctrieP++) {
	    if (ch == ctrieP->tn_key)
		break;
	 }
        if( j == numNextKeys )
        {   *dbufLenP = save_dLen;   
            ibufTrieP[wKeyPos] = save_itP;
            *cTriePtrP = save_ctP;
            return(0);
          }
	for (j = 0; j < hztbl->keyprompt[ch].ptlen; j++) {
	    dbuf[ (*dbufLenP)++ ] = hztbl->keyprompt[ch].prompt[j];
	}
    }
   *cTriePtrP = ctrieP;
   initBufagain(hztbl);
   return(1);
}

int 
WildKeyState()
{
   return(wildKeyOK);
}

int 
firstMatchKey()
{
   return( (cMatchKey>0) ? 0 : 1);
}

int 
lastMatchKey()
{
   return( (cMatchKey == numMatchKey-1) ? 1 : 0);
}

int 
saveWildKey()
{
   save_cMatchKey = cMatchKey;
}

int 
restoreWildKey(ibufLen, ibuf)
int ibufLen;
char *ibuf;
{
   cMatchKey = save_cMatchKey;
   memcpy( ibuf, wildKeyP[cMatchKey].wk_key, ibufLen);
}

int
updateWildKey(ibufLen)
int ibufLen;
{
   if( wildKeyOK > 1 && wKeyPos == ibufLen )
       wildKeyOK--;
}

int resetWildKey()
{
   if( wildKeyOK > 1 ) wildKeyOK = 1;
}

int
showHZfullCode(hztbl, inKey, keyLen, hzidx, screen)
   HZinputTable *hztbl;
   char *inKey;
   int hzidx, keyLen;
   TScreen *screen;
{
   register trieNode *ctrieP=hztbl->trieList;
   trieNode *htrieP=hztbl->trieList;
   int numNextKeys;
   register int i;

   if( hztbl->encode == GB_ENCODE )
      memcpy(fcbuf, "\310\253\302\353\241\372", 6);
   else
      memcpy(fcbuf, "\245\376\275\130\241\367", 6);
   fcbufLen = 6;
   for( i=0; i<keyLen; i++ )
   {  register int j;
      numNextKeys = ctrieP->tn_numNextKeys;
      ctrieP = &(htrieP[ctrieP->tn_nextKeys]);
      for( j=0; j<numNextKeys; ctrieP++,j++ )
         if( inKey[i] == ctrieP->tn_key )
             break; 
      fcbuf[fcbufLen++] = inKey[i];
     }
  
   while( ctrieP->tn_numNextKeys )
   {  numNextKeys = ctrieP->tn_numNextKeys;
      ctrieP=&(htrieP[ctrieP->tn_nextKeys]);
      for (i = 0; i<numNextKeys-1; i++) {
	register int j;
        if( (ctrieP+i)->tn_hzidx > hzidx )
            goto exit_l;
        if( (ctrieP+i)->tn_hzidx <= hzidx && 
            (ctrieP+i+1)->tn_hzidx > hzidx )
            break;
       }
      fcbuf[fcbufLen++] = (ctrieP+i)->tn_key;
      ctrieP = ctrieP + i;
     }
exit_l:
   fCodeLen = fcbufLen - 6;
   memcpy( fCodebuf, fcbuf, fCodeLen );
   if( oldLen > fcbufLen )
   {   for( i=fcbufLen; i<oldLen; i++ )
            fcbuf[ fcbufLen++ ] = ' ';
      }
   else 
        oldLen = fcbufLen; 
   i = screen->max_col - fcbufLen;
   hzi_showUserInput (screen, i);
   fcbufLen = 6;  /* reset length */
}
 
int
reshowHZfullCode(screen)
   TScreen *screen;
{
   register int i;

   memcpy( fcbuf, fCodebuf, fCodeLen );
   fcbufLen += fCodeLen;
   if( oldLen > fcbufLen )
   {   for( i=fcbufLen; i<oldLen; i++ )
            fcbuf[ fcbufLen++ ] = ' ';
      }
   else 
        oldLen = fcbufLen; 
   i = screen->max_col - fcbufLen;
   hzi_showUserInput (screen, i);
   fcbufLen = 6;  /* reset length */
}

hzi_showUserInput( screen, pos)
        int pos;
	TScreen * screen ;
{
 Window window ; 

    window = TextWindow( screen );
	HZ_XDrawImageStringMix (screen->display, TextWindow(screen),
		screen->normalGC, screen->hz_normalGC,
		screen->hzIwin.x + FontWidth(screen) * pos,
		screen->hzIwin.y + FontAscent(screen),
		(char *)fcbuf, fcbufLen,
		FontWidth(screen));
	XFlush( screen->display );
}

int
saveCachtoFile(hztbl, hztyp, screen)
    HZinputTable *hztbl;
    TScreen *screen;
    HZinputType *hztyp;
{
    FILE *file;
    unsigned long size;
    char tmpstr[80];

    if( hztbl->autoStudy == 0 )
        return(0);
    HZi_ShowMesg (screen, "Saving input table ...");
    if( (file=fopen (hztyp->fontName, "r+")) == NULL )
    { sprintf (tmpstr, "Unable to save input table for %s", hztyp->fontName);
	HZi_ShowMesg (screen, tmpstr);
	return(-1);
      }
    size = 2 + sizeof(HZinputTable) + sizeof(trieNode)*hztbl->sizeTrieList
       + sizeof(char) * hztbl->sizeHZList;
    fseek(file, size, 0);
    fwrite(hztbl->cachTab1, sizeof(CACH1), hztbl->maxchoice * 
           hztyp->totalValidKey, file);
    fwrite(hztbl->cachTab2, sizeof(CACH2), hztbl->maxchoice *
           hztyp->totalValidKey * hztyp->totalValidKey, file);
    fclose(file);
    return(0);
}

loadInTab_a(file, dir, name, hztbl, hztyp, screen)
    char *name, *dir;
    FILE *file;
    HZinputTable *hztbl;
    TScreen *screen;
    HZinputType *hztyp;
{ 
     char tmpstr[80];
     register int totalValidKey, i;

     for( totalValidKey=0,i=0; i<128; i++ )
       if( (hztbl->keytype[i] & HZ_KEY_INPUT_MASK) &&
           (hztbl->keytype[i] != HZ_KEY_WILDKEY)    )
           hztyp->numValidKeyP[i] = totalValidKey++;
       else  hztyp->numValidKeyP[i] = 0xff;
     hztyp->totalValidKey = totalValidKey;
     hztyp->inKeyCount = 0;

     if( hztbl->autoStudy )
     { int  maxChoice=hztbl->maxchoice;
       unsigned char *numValidKeyP=hztyp->numValidKeyP;
       CACH1 *cachTab1;
       CACH2 *cachTab2;

       cachTab1 = (CACH1 *)malloc(totalValidKey * 
                maxChoice * sizeof(CACH1) );
       cachTab2 = (CACH2 *)malloc(totalValidKey * 
          totalValidKey * maxChoice * sizeof(CACH2) );
       hztbl->cachTab1 = cachTab1;
       hztbl->cachTab2 = cachTab2;
       if( (! cachTab1) || (! cachTab2) ) {
	    sprintf(tmpstr, "No memory to load input table for %s", name);
	    HZi_ShowMesg (screen, tmpstr);
            myfree(hztbl);
            fclose(file);
	    return(-1);
	  }
       if( (fread(cachTab1, sizeof(CACH1), maxChoice*totalValidKey, file)
         != maxChoice*totalValidKey) || (fread(cachTab2, sizeof(CACH2), 
         maxChoice*totalValidKey*totalValidKey, file) != 
         maxChoice*totalValidKey*totalValidKey) )
        {
	    sprintf(tmpstr, "Error in loading input table for %s", name);
	    HZi_ShowMesg (screen, tmpstr);
            myfree(hztbl);
            fclose(file);
	    return(-1);
          }
      }
    wildKeyOK = 0;
    for( i=0; i<128; i++ )
       if( (hztbl->keytype[i] == HZ_KEY_WILDKEY) )
           wildKeyOK++;
    if( wildKeyOK == 1 )
    {  if( maxMatchKey == 0 )
       {   if((wildKeyP=(WILDKEY *)malloc(hztyp->totalValidKey*sizeof(WILDKEY)))
              == NULL ) {
	    sprintf(tmpstr, "Error in alloc Mem for input table for %s", name);
	    HZi_ShowMesg (screen, tmpstr);
            myfree(hztbl);
            fclose(file);
            return( -1 );
           } 
           maxMatchKey = hztyp->totalValidKey;
         }           
       else if( maxMatchKey < hztyp->totalValidKey )
       {   register WILDKEY *cwkPtr;
           if((cwkPtr=(WILDKEY *)malloc(hztyp->totalValidKey*sizeof(WILDKEY)))
              == NULL ) 
	   { sprintf(tmpstr, "Error in alloc Mem for input table for %s", name);
	     HZi_ShowMesg (screen, tmpstr);
             myfree(hztbl);
             fclose(file);
             return( -1 );
            }
           maxMatchKey = hztyp->totalValidKey;
           free(wildKeyP);
           wildKeyP = cwkPtr;        
         }
     }
    else wildKeyOK = 0;
           /* load LX dictionary */
    if( hztbl->lxDic == 0 )
        return 0;
    { FILE *rfp;
      lxState = 0;
      tmpstr[0] = '\0';
      if( dir != NULL )
      {   strcpy(tmpstr, dir);
          strcat(tmpstr,"/");
         }
      if( hztbl->encode == GB_ENCODE )
      {   strcat(tmpstr,"gblx.dic");
          if( (rfp=fopen(tmpstr,"r")) == NULL )
          { sprintf(tmpstr, "Error in load for LX Dic. for %s", name);
	    HZi_ShowMesg (screen, tmpstr);
            return(-1);
           }
          if( gblx == NULL )
          {   gblx = lxDic;
              big5lx = lxDic;
              fread(gblx, TOTAL, LENGTH, rfp);
             }
          fclose(rfp);
         }
      else
      {   strcat(tmpstr,"big5lx.dic");
          if( (rfp=fopen(tmpstr,"r")) == NULL )
          { sprintf(tmpstr, "Error in load for LX Dic. for %s", name);
	    HZi_ShowMesg (screen, tmpstr);
            return(-1);
           }
          if( big5lx == NULL )
          {   big5lx = lxDic;
              gblx = NULL;
              fread(big5lx, TOTAL, LENGTH, rfp);
             }
          fclose(rfp);
         }
      }
    return(0);
}

extern freelxdic()
{
    gblx = NULL;
    big5lx = NULL;
}
static int
myfree(hztbl)
   HZinputTable *hztbl;
{
   free (hztbl->trieList);
   free (hztbl->hzList);
   free (hztbl->hzList);
   if( hztbl->cachTab1 )  free(hztbl->cachTab1);
   if( hztbl->cachTab2 )  free(hztbl->cachTab2);
}

int
hzListRelIdx(n, startIdx, hztbl)
HZinputTable *hztbl;
int n, startIdx;
{
     register int i, idx;
     for( idx=startIdx,i=0; i<n; i++ )
      {   idx += (unsigned)hztbl->hzList[idx] + 1;          }
     return(idx-startIdx);
}

int
hzListAbsIdx(hztbl, HZbuf)
HZinputTable *hztbl;
unsigned char *HZbuf;
{
     int addr;
     register unsigned char *hzP=hztbl->hzList+1;
     while( 1 )
     {  while( *hzP != '\0' && *hzP != *HZbuf )
           hzP += (unsigned)(*(hzP-1)) + 1; 
        if( *hzP == '\0' )  return(-1);
        if( *(hzP+1) == *(HZbuf+1) && *(hzP-1) == 2 )
           break;
        hzP += (unsigned)(*(hzP-1)) + 1; 
       }
     addr = hzP - hztbl->hzList - 1;
     return(addr);
}

CACH1 *
getCach1Idx(keyP, hztbl, hztyp)
char *keyP;
HZinputTable *hztbl;
HZinputType *hztyp;
{
     int address;
        /* for level 1 Cache */
     address = ((unsigned)hztyp->numValidKeyP[keyP[0]])*hztbl->maxchoice;
     return( &(hztbl->cachTab1[address]) );
}
CACH2 *
getCach2Idx(keyP, hztbl, hztyp)
char *keyP;
HZinputTable *hztbl;
HZinputType *hztyp;
{
     int address;
       /* for level 2 Cache */
     address = ((unsigned)hztyp->numValidKeyP[keyP[0]])*hztyp->totalValidKey;
     address = (address + (unsigned)hztyp->numValidKeyP[keyP[1]]) * 
                  hztbl->maxchoice;
     return( &(hztbl->cachTab2[address]) );
}

int
updateCach(keyP, keyLen, hzstrIdx, hztbl, hztyp)
char *keyP;
int keyLen;
int hzstrIdx;
HZinputTable *hztbl;
HZinputType *hztyp;
{
     register int addr, i;

     if( hztbl->autoStudy == 0 ) return 0; 
    {register CACH1 *cachP;
     cachP = &hztbl->cachTab1[(unsigned)hztyp->numValidKeyP[keyP[0]] 
                              * hztbl->maxchoice];
     addr = hzIdxTrieNode1(keyP, &hztbl->trieList[0]);
     addr = hzstrIdx - addr;
     for( i=0; i<hztbl->maxchoice; i++ )
        if( cachP[i] == addr )  
        {   moveCach1(cachP, i, hztbl->maxchoice, addr);
            break;
           }
     if( i >= hztbl->maxchoice ) 
      {    moveCach1(cachP, -1, hztbl->maxchoice, addr);   }
     if( keyLen < 2 )  
     {  register trieNode *ctrieP=hztbl->trieList;
        addr = ctrieP->tn_numNextKeys;
        ctrieP = &(hztbl->trieList[ctrieP->tn_nextKeys]);
        for( i=0; i<addr; ctrieP++,i++ )
         if( keyP[0] == ctrieP->tn_key )
             break; 
        if( i == addr ) return(0);
        addr = ctrieP->tn_numNextKeys;
        ctrieP=&(hztbl->trieList[ctrieP->tn_nextKeys]);
        for (i = 0; i<addr-1; i++) 
        {  if( (ctrieP+i)->tn_hzidx > hzstrIdx )
                return(0);
          if( (ctrieP+i)->tn_hzidx <= hzstrIdx && 
              (ctrieP+i+1)->tn_hzidx > hzstrIdx )
                break;
         }
        keyP[1] = (ctrieP+i)->tn_key;
       }
     }
     { register CACH2 *cachP;
     addr = ((unsigned)hztyp->numValidKeyP[keyP[0]])*hztyp->totalValidKey;
     cachP = &hztbl->cachTab2[(addr
            + (unsigned)hztyp->numValidKeyP[keyP[1]])*hztbl->maxchoice];
     addr = hzIdxTrieNode2(keyP, &hztbl->trieList[0]);
     if( (addr = hzstrIdx - addr) > 0xffff ) /* only cache offset short */
         return;
     for( i=0; i<hztbl->maxchoice; i++ )
        if( cachP[i] == addr )  
        {   moveCach2(cachP, i, hztbl->maxchoice, addr);
            break;
           }
     if( i >= hztbl->maxchoice ) 
      {    moveCach2(cachP, -1, hztbl->maxchoice, addr);   }
     }
}

static int hzIdxTrieNode2(keyP, trieP)
char *keyP;
trieNode *trieP;
{
    register int i, j;
    register trieNode *cTP;
    for( i=0; i<trieP->tn_numNextKeys; i++ )
    {  cTP = trieP + i + 1;
       if( keyP[0] == cTP->tn_key ) 
       {  register int n=cTP->tn_numNextKeys;
          for( j=0; j<n; j++ )
             if( keyP[1] == (trieP+cTP->tn_nextKeys+j)->tn_key) break;
          if( j < n )
             return( (trieP+cTP->tn_nextKeys+j)->tn_hzidx );
          else  return( -1 );
         }
      }
    return( -1 );
}

static int hzIdxTrieNode1(keyP, trieP)
char *keyP;
trieNode *trieP;
{
    register int i;
    for( i=0; i<trieP->tn_numNextKeys; i++ )
       if( keyP[0] == (trieP+i+1)->tn_key ) break;
    if( i<trieP->tn_numNextKeys )
       return( (trieP+i+1)->tn_hzidx );
    else 
       return( -1 );
}
static int
moveCach1(cachP, cPos, maxcachLen, hzstrIdx)
int maxcachLen, cPos, hzstrIdx;
CACH1 *cachP; 
{
     register int i;
     int t;
     if( cPos > 1 )    
     {   t = cachP[cPos];
         for( i=cPos-1; i>0; i-- )
            cachP[i+1] = cachP[i];
         cachP[1] = t;
       }
     else if( cPos < 0 )
      {  for( i=maxcachLen-2; i>0; i-- )
            cachP[i+1] = cachP[i];
         cachP[1] = hzstrIdx; 
        }
}
static int
moveCach2(cachP, cPos, maxcachLen, hzstrIdx)
int maxcachLen, cPos, hzstrIdx;
CACH2 *cachP; 
{
     register int i;
     int t;
     if( cPos > 1 )    
     {   t = cachP[cPos];
         for( i=cPos-1; i>0; i-- )
            cachP[i+1] = cachP[i];
         cachP[1] = t;
       }
     else if( cPos < 0 )
      {  for( i=maxcachLen-2; i>0; i-- )
            cachP[i+1] = cachP[i];
         cachP[1] = hzstrIdx; 
        }
}

int
initLXCZ(hztbl, hztyp)
    HZinputTable *hztbl;
    HZinputType  *hztyp;
{
    register int i;
    wildKeyOK = 0;
    for( i=0; i<128; i++ )
       if( (hztbl->keytype[i] == HZ_KEY_WILDKEY) )
           wildKeyOK++;
    if( wildKeyOK > 1 )  wildKeyOK = 0;
    cMatchKey = wKeyPos = 0,
    lxState = lxContinue = oldHZitem = 0;
}

checkCach(screen, hztbl, hztyp, keyP, hzstrIdx)
    char *keyP;
    int hzstrIdx;
    HZinputTable *hztbl;
    HZinputType *hztyp;
    TScreen *screen;
{
     register int addr, i;
     char tmpstr[128];
     if( hztbl->autoStudy == 0 ) return 0; 
    {register CACH1 *cachP;
     cachP = &hztbl->cachTab1[(unsigned)hztyp->numValidKeyP[keyP[0]] 
                              * hztbl->maxchoice];
     addr = hzIdxTrieNode1(keyP, &hztbl->trieList[0]);
     for( i=0; i<hztbl->maxchoice; i++ )
        if( (unsigned)(hztbl->hzList[cachP[i]+addr]) > 80 )  
        {   sprintf(tmpstr, "Error in Cach1 %d %d %d",i, 
                    cachP[i]+addr, hzstrIdx);
	    HZi_ShowMesg (screen, tmpstr);
           }
     }
     { register CACH2 *cachP;
     addr = ((unsigned)hztyp->numValidKeyP[keyP[0]])*hztyp->totalValidKey;
     cachP = &hztbl->cachTab2[(addr
            + (unsigned)hztyp->numValidKeyP[keyP[1]])*hztbl->maxchoice];
     addr = hzIdxTrieNode2(keyP, &hztbl->trieList[0]);
     for( i=0; i<hztbl->maxchoice; i++ )
        if( (unsigned)(hztbl->hzList[cachP[i]+addr]) > 80 )  
        {   sprintf(tmpstr, "Error in Cach1 %d %d %d",i, 
                    cachP[i]+addr, hzstrIdx);
	    HZi_ShowMesg (screen, tmpstr);
           }
     }
}
